* = $0000

; --- Jump to init
	nop
	nop
	nop
	jmp simple_init

* = $0100
; includes
DRIVER_RAM_BASE = simple_end_of_program ; reserve space for monitor data in zero page
!source "lcd.s"
!source "keyboard.s"
!source "console.s"
!source "monitor.s"
!source "app.s"
	
; --- Simple init
simple_init:
	lda #<simple_isr
	sta $00FFFE
	lda #>simple_isr
	sta $00FFFF	
	+app_init
				
	jsr lcd_standard_init
	jsr keyboard_standard_init
	jsr console_standard_init
	jsr print_title
	
	lda #1
	jsr console_enable_cursor
	
	cli
	
	; enter the monitor program
	jsr init_monitor 

	halt

; --- Interrupt service routine	
simple_isr:
	php
	phb
	pha
	phy
	phx
	
	lda APP_ADR_PROGRAM_BANK
	bank
	
	; was the interrupt triggered by the keyboard?
	lda KEYBOARD_ADR_CONTROL
	and #$1
	bne +
	lda KEYBOARD_ADR_DATA
	jsr keyboard_handle_scan_code
			
+	plx
	ply
	pla
	plb
	plp
	
	rtl ; returns to bank 0 wrapper
		

 
print_title:
	ldx #$00
	
-	lda monitor_demo_titlestr,X
	beq +
	
	phx
	jsr lcd_write_char
	plx
	inx
	
	; terminate after 256 chars, even if NULL is not reached
	bne -

+	rts

	
monitor_demo_titlestr:	
!text "BMOW system monitor", 13, "adapted from Apple II", 0
	
simple_end_of_program:
	