#pragma once


namespace Simulator {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Collections::Generic;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::Globalization;

	ref class MachineState;
	ref class Disassembly;
	ref class MicroDisassembly;

	public value class FileAndLine 
	{
	public:
		String^ filename;
		int lineNumber;
		String^ sourceLabel;
	};

	/// <summary>
	/// Summary for MainForm
	///
	/// WARNING: If you change the name of this class, you will need to change the
	///          'Resource File Name' property for the managed resource compiler tool
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public ref class MainForm : public System::Windows::Forms::Form
	{
	public:
		MainForm(void)
		{
			InitializeComponent();	

			m_ignoreSource = false;
		}
	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~MainForm()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::TextBox^  m_consoleTextBox;
	private: System::Windows::Forms::Label^  m_consoleTextBoxLabel;
	protected: 

	protected: 

	private: System::Windows::Forms::TextBox^  m_lcdTextBox;
	private: System::Windows::Forms::Label^  m_pcLabel;
	private: System::Windows::Forms::Label^  m_arLabel;

	private: System::Windows::Forms::Label^  m_spLabel;


	private: System::Windows::Forms::Label^  m_aLabel;
	private: System::Windows::Forms::Label^  m_xLabel;
	private: System::Windows::Forms::Label^  m_yLabel;
	private: System::Windows::Forms::Label^  m_tLabel;
	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::Label^  label2;
	private: System::Windows::Forms::Label^  label3;
	private: System::Windows::Forms::Label^  label4;
	private: System::Windows::Forms::Label^  m_opcodeLabel;

	private: System::Windows::Forms::Label^  label6;
	private: System::Windows::Forms::Label^  label7;
	private: System::Windows::Forms::Label^  label8;
	private: System::Windows::Forms::Label^  label9;
	private: System::Windows::Forms::Label^  label10;
	private: System::Windows::Forms::TextBox^  m_memoryViewTextBox;

	private: System::Windows::Forms::Label^  label11;
	private: System::Windows::Forms::RadioButton^  m_cRadioButton;
	private: System::Windows::Forms::RadioButton^  m_nRadioButton;
	private: System::Windows::Forms::RadioButton^  m_zRadioButton;
	private: System::Windows::Forms::RadioButton^  m_vRadioButton;
	private: System::Windows::Forms::RadioButton^  m_aRadioButton;
	private: System::Windows::Forms::RadioButton^  m_ieRadioButton;
	private: System::Windows::Forms::TextBox^  m_memoryAddressTextBox;



	private: System::Windows::Forms::Button^  m_continueButtton;
	private: System::Windows::Forms::Button^  m_pauseButton;
	private: System::Windows::Forms::Button^  m_resetButton;
	private: System::Windows::Forms::Label^  label12;



	private: System::Windows::Forms::Button^  m_stepButton;
	private: System::Windows::Forms::Button^  m_microStepButton;
	private: System::Windows::Forms::Label^  label13;
	private: System::Windows::Forms::Label^  m_phaseLabel;
	private: System::Windows::Forms::Panel^  panel1;
	private: System::Windows::Forms::RadioButton^  m_irqRadioButton;
	private: System::Windows::Forms::Label^  m_microDisassemblyViewTitle;



	private: System::Windows::Forms::Label^  m_opLabel;
	private: System::Windows::Forms::Label^  label14;


	private: System::Windows::Forms::ToolTip^  m_tooltip;
	private: System::Windows::Forms::ListView^  m_sourceListView;
	private: System::Windows::Forms::ImageList^  m_debuggerImageList;
	private: System::Windows::Forms::ColumnHeader^  columnHeader1;
	private: System::Windows::Forms::ListView^  m_microSourceListView;
	private: System::Windows::Forms::ColumnHeader^  columnHeader2;
	private: System::Windows::Forms::Button^  m_clearBreakpointsButton;
	private: System::Windows::Forms::MenuStrip^  menuStrip1;
	private: System::Windows::Forms::ToolStripMenuItem^  fileToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  openProgramROMToolStripMenuItem;

	private: System::Windows::Forms::ToolStripSeparator^  toolStripMenuItem1;
	private: System::Windows::Forms::ToolStripMenuItem^  exitToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  toolStripMenuItem2;
	private: System::Windows::Forms::CheckBox^  m_ShowDisassemblyCheckbox;
	private: System::Windows::Forms::Button^  m_stepInButton;
	private: System::Windows::Forms::Button^  m_stepOutButton;
	private: System::Windows::Forms::ListView^  m_callStackListView;

	private: System::Windows::Forms::ColumnHeader^  columnHeader3;
private: System::Windows::Forms::Label^  m_callStackTitle;
private: System::Windows::Forms::ToolStripMenuItem^  toolStripMenuItem3;
private: System::Windows::Forms::ToolStripMenuItem^  toolStripMenuItem4;
private: System::Windows::Forms::ToolStripMenuItem^  toolStripMenuItem5;
private: System::Windows::Forms::ToolStripMenuItem^  toolStripMenuItem6;

	private: System::ComponentModel::IContainer^  components;







	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>


#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(MainForm::typeid));
			this->m_consoleTextBox = (gcnew System::Windows::Forms::TextBox());
			this->m_consoleTextBoxLabel = (gcnew System::Windows::Forms::Label());
			this->m_lcdTextBox = (gcnew System::Windows::Forms::TextBox());
			this->m_pcLabel = (gcnew System::Windows::Forms::Label());
			this->m_arLabel = (gcnew System::Windows::Forms::Label());
			this->m_spLabel = (gcnew System::Windows::Forms::Label());
			this->m_aLabel = (gcnew System::Windows::Forms::Label());
			this->m_xLabel = (gcnew System::Windows::Forms::Label());
			this->m_yLabel = (gcnew System::Windows::Forms::Label());
			this->m_tLabel = (gcnew System::Windows::Forms::Label());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->label2 = (gcnew System::Windows::Forms::Label());
			this->label3 = (gcnew System::Windows::Forms::Label());
			this->label4 = (gcnew System::Windows::Forms::Label());
			this->m_opcodeLabel = (gcnew System::Windows::Forms::Label());
			this->label6 = (gcnew System::Windows::Forms::Label());
			this->label7 = (gcnew System::Windows::Forms::Label());
			this->label8 = (gcnew System::Windows::Forms::Label());
			this->label9 = (gcnew System::Windows::Forms::Label());
			this->label10 = (gcnew System::Windows::Forms::Label());
			this->m_memoryViewTextBox = (gcnew System::Windows::Forms::TextBox());
			this->label11 = (gcnew System::Windows::Forms::Label());
			this->m_cRadioButton = (gcnew System::Windows::Forms::RadioButton());
			this->m_nRadioButton = (gcnew System::Windows::Forms::RadioButton());
			this->m_zRadioButton = (gcnew System::Windows::Forms::RadioButton());
			this->m_vRadioButton = (gcnew System::Windows::Forms::RadioButton());
			this->m_aRadioButton = (gcnew System::Windows::Forms::RadioButton());
			this->m_ieRadioButton = (gcnew System::Windows::Forms::RadioButton());
			this->m_memoryAddressTextBox = (gcnew System::Windows::Forms::TextBox());
			this->m_continueButtton = (gcnew System::Windows::Forms::Button());
			this->m_pauseButton = (gcnew System::Windows::Forms::Button());
			this->m_resetButton = (gcnew System::Windows::Forms::Button());
			this->label12 = (gcnew System::Windows::Forms::Label());
			this->m_stepButton = (gcnew System::Windows::Forms::Button());
			this->m_microStepButton = (gcnew System::Windows::Forms::Button());
			this->label13 = (gcnew System::Windows::Forms::Label());
			this->m_phaseLabel = (gcnew System::Windows::Forms::Label());
			this->panel1 = (gcnew System::Windows::Forms::Panel());
			this->m_opLabel = (gcnew System::Windows::Forms::Label());
			this->m_irqRadioButton = (gcnew System::Windows::Forms::RadioButton());
			this->m_microDisassemblyViewTitle = (gcnew System::Windows::Forms::Label());
			this->label14 = (gcnew System::Windows::Forms::Label());
			this->m_tooltip = (gcnew System::Windows::Forms::ToolTip(this->components));
			this->m_sourceListView = (gcnew System::Windows::Forms::ListView());
			this->columnHeader1 = (gcnew System::Windows::Forms::ColumnHeader());
			this->m_debuggerImageList = (gcnew System::Windows::Forms::ImageList(this->components));
			this->m_microSourceListView = (gcnew System::Windows::Forms::ListView());
			this->columnHeader2 = (gcnew System::Windows::Forms::ColumnHeader());
			this->m_clearBreakpointsButton = (gcnew System::Windows::Forms::Button());
			this->menuStrip1 = (gcnew System::Windows::Forms::MenuStrip());
			this->fileToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->openProgramROMToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripMenuItem2 = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripMenuItem3 = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripMenuItem4 = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripMenuItem5 = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripMenuItem6 = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripMenuItem1 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->exitToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->m_ShowDisassemblyCheckbox = (gcnew System::Windows::Forms::CheckBox());
			this->m_stepInButton = (gcnew System::Windows::Forms::Button());
			this->m_stepOutButton = (gcnew System::Windows::Forms::Button());
			this->m_callStackListView = (gcnew System::Windows::Forms::ListView());
			this->columnHeader3 = (gcnew System::Windows::Forms::ColumnHeader());
			this->m_callStackTitle = (gcnew System::Windows::Forms::Label());
			this->panel1->SuspendLayout();
			this->menuStrip1->SuspendLayout();
			this->SuspendLayout();
			// 
			// m_consoleTextBox
			// 
			this->m_consoleTextBox->AcceptsReturn = true;
			this->m_consoleTextBox->AcceptsTab = true;
			this->m_consoleTextBox->Anchor = static_cast<System::Windows::Forms::AnchorStyles>(((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left));
			this->m_consoleTextBox->Font = (gcnew System::Drawing::Font(L"Courier New", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->m_consoleTextBox->Location = System::Drawing::Point(9, 360);
			this->m_consoleTextBox->Multiline = true;
			this->m_consoleTextBox->Name = L"m_consoleTextBox";
			this->m_consoleTextBox->ScrollBars = System::Windows::Forms::ScrollBars::Vertical;
			this->m_consoleTextBox->Size = System::Drawing::Size(476, 431);
			this->m_consoleTextBox->TabIndex = 0;
			this->m_consoleTextBox->Text = L"AAAAAAAAAABBBBBBBBBBAAAAAAAAAABBBBBBBBBBAAAAAAAAAABBBBBBBBBBCCCC";
			this->m_consoleTextBox->WordWrap = false;
			this->m_consoleTextBox->KeyPress += gcnew System::Windows::Forms::KeyPressEventHandler(this, &MainForm::m_lcdTextBox_KeyPress);
			// 
			// m_consoleTextBoxLabel
			// 
			this->m_consoleTextBoxLabel->Anchor = static_cast<System::Windows::Forms::AnchorStyles>(((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->m_consoleTextBoxLabel->AutoSize = true;
			this->m_consoleTextBoxLabel->Location = System::Drawing::Point(6, 344);
			this->m_consoleTextBoxLabel->Name = L"m_consoleTextBoxLabel";
			this->m_consoleTextBoxLabel->Size = System::Drawing::Size(75, 13);
			this->m_consoleTextBoxLabel->TabIndex = 1;
			this->m_consoleTextBoxLabel->Text = L"Video Console";
			// 
			// m_lcdTextBox
			// 
			this->m_lcdTextBox->BackColor = System::Drawing::SystemColors::Window;
			this->m_lcdTextBox->Font = (gcnew System::Drawing::Font(L"Courier New", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->m_lcdTextBox->Location = System::Drawing::Point(114, 93);
			this->m_lcdTextBox->Multiline = true;
			this->m_lcdTextBox->Name = L"m_lcdTextBox";
			this->m_lcdTextBox->ReadOnly = true;
			this->m_lcdTextBox->Size = System::Drawing::Size(199, 39);
			this->m_lcdTextBox->TabIndex = 2;
			this->m_lcdTextBox->Text = L"AAAAAABBBBBBCCCCCCDDDDDD";
			this->m_lcdTextBox->KeyPress += gcnew System::Windows::Forms::KeyPressEventHandler(this, &MainForm::m_lcdTextBox_KeyPress);
			// 
			// m_pcLabel
			// 
			this->m_pcLabel->AutoSize = true;
			this->m_pcLabel->BackColor = System::Drawing::SystemColors::Window;
			this->m_pcLabel->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->m_pcLabel->Font = (gcnew System::Drawing::Font(L"Courier New", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->m_pcLabel->Location = System::Drawing::Point(114, 8);
			this->m_pcLabel->Name = L"m_pcLabel";
			this->m_pcLabel->Size = System::Drawing::Size(58, 18);
			this->m_pcLabel->TabIndex = 3;
			this->m_pcLabel->Text = L"ABCDEF";
			// 
			// m_arLabel
			// 
			this->m_arLabel->AutoSize = true;
			this->m_arLabel->BackColor = System::Drawing::SystemColors::Window;
			this->m_arLabel->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->m_arLabel->Font = (gcnew System::Drawing::Font(L"Courier New", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->m_arLabel->Location = System::Drawing::Point(114, 34);
			this->m_arLabel->Name = L"m_arLabel";
			this->m_arLabel->Size = System::Drawing::Size(58, 18);
			this->m_arLabel->TabIndex = 4;
			this->m_arLabel->Text = L"ABCDEF";
			// 
			// m_spLabel
			// 
			this->m_spLabel->AutoSize = true;
			this->m_spLabel->BackColor = System::Drawing::SystemColors::Window;
			this->m_spLabel->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->m_spLabel->Font = (gcnew System::Drawing::Font(L"Courier New", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->m_spLabel->Location = System::Drawing::Point(114, 61);
			this->m_spLabel->Name = L"m_spLabel";
			this->m_spLabel->Size = System::Drawing::Size(58, 18);
			this->m_spLabel->TabIndex = 5;
			this->m_spLabel->Text = L"ABCDEF";
			// 
			// m_aLabel
			// 
			this->m_aLabel->AutoSize = true;
			this->m_aLabel->BackColor = System::Drawing::SystemColors::Window;
			this->m_aLabel->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->m_aLabel->Font = (gcnew System::Drawing::Font(L"Courier New", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->m_aLabel->Location = System::Drawing::Point(23, 8);
			this->m_aLabel->Name = L"m_aLabel";
			this->m_aLabel->Size = System::Drawing::Size(26, 18);
			this->m_aLabel->TabIndex = 6;
			this->m_aLabel->Text = L"AB";
			// 
			// m_xLabel
			// 
			this->m_xLabel->AutoSize = true;
			this->m_xLabel->BackColor = System::Drawing::SystemColors::Window;
			this->m_xLabel->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->m_xLabel->Font = (gcnew System::Drawing::Font(L"Courier New", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->m_xLabel->Location = System::Drawing::Point(23, 34);
			this->m_xLabel->Name = L"m_xLabel";
			this->m_xLabel->Size = System::Drawing::Size(26, 18);
			this->m_xLabel->TabIndex = 7;
			this->m_xLabel->Text = L"AB";
			// 
			// m_yLabel
			// 
			this->m_yLabel->AutoSize = true;
			this->m_yLabel->BackColor = System::Drawing::SystemColors::Window;
			this->m_yLabel->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->m_yLabel->Font = (gcnew System::Drawing::Font(L"Courier New", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->m_yLabel->Location = System::Drawing::Point(23, 61);
			this->m_yLabel->Name = L"m_yLabel";
			this->m_yLabel->Size = System::Drawing::Size(26, 18);
			this->m_yLabel->TabIndex = 8;
			this->m_yLabel->Text = L"AB";
			// 
			// m_tLabel
			// 
			this->m_tLabel->AutoSize = true;
			this->m_tLabel->BackColor = System::Drawing::SystemColors::Window;
			this->m_tLabel->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->m_tLabel->Font = (gcnew System::Drawing::Font(L"Courier New", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->m_tLabel->Location = System::Drawing::Point(23, 88);
			this->m_tLabel->Name = L"m_tLabel";
			this->m_tLabel->Size = System::Drawing::Size(26, 18);
			this->m_tLabel->TabIndex = 9;
			this->m_tLabel->Text = L"AB";
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->label1->Location = System::Drawing::Point(3, 9);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(14, 13);
			this->label1->TabIndex = 10;
			this->label1->Text = L"A";
			// 
			// label2
			// 
			this->label2->AutoSize = true;
			this->label2->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->label2->Location = System::Drawing::Point(3, 35);
			this->label2->Name = L"label2";
			this->label2->Size = System::Drawing::Size(14, 13);
			this->label2->TabIndex = 11;
			this->label2->Text = L"X";
			// 
			// label3
			// 
			this->label3->AutoSize = true;
			this->label3->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->label3->Location = System::Drawing::Point(3, 62);
			this->label3->Name = L"label3";
			this->label3->Size = System::Drawing::Size(14, 13);
			this->label3->TabIndex = 12;
			this->label3->Text = L"Y";
			// 
			// label4
			// 
			this->label4->AutoSize = true;
			this->label4->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->label4->Location = System::Drawing::Point(3, 89);
			this->label4->Name = L"label4";
			this->label4->Size = System::Drawing::Size(14, 13);
			this->label4->TabIndex = 13;
			this->label4->Text = L"T";
			// 
			// m_opcodeLabel
			// 
			this->m_opcodeLabel->AutoSize = true;
			this->m_opcodeLabel->BackColor = System::Drawing::SystemColors::Window;
			this->m_opcodeLabel->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->m_opcodeLabel->Font = (gcnew System::Drawing::Font(L"Courier New", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->m_opcodeLabel->Location = System::Drawing::Point(259, 34);
			this->m_opcodeLabel->Name = L"m_opcodeLabel";
			this->m_opcodeLabel->Size = System::Drawing::Size(26, 18);
			this->m_opcodeLabel->TabIndex = 14;
			this->m_opcodeLabel->Text = L"AB";
			// 
			// label6
			// 
			this->label6->AutoSize = true;
			this->label6->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->label6->Location = System::Drawing::Point(208, 35);
			this->label6->Name = L"label6";
			this->label6->Size = System::Drawing::Size(45, 13);
			this->label6->TabIndex = 15;
			this->label6->Text = L"Opcode";
			// 
			// label7
			// 
			this->label7->AutoSize = true;
			this->label7->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->label7->Location = System::Drawing::Point(87, 9);
			this->label7->Name = L"label7";
			this->label7->Size = System::Drawing::Size(21, 13);
			this->label7->TabIndex = 16;
			this->label7->Text = L"PC";
			// 
			// label8
			// 
			this->label8->AutoSize = true;
			this->label8->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->label8->Location = System::Drawing::Point(87, 62);
			this->label8->Name = L"label8";
			this->label8->Size = System::Drawing::Size(21, 13);
			this->label8->TabIndex = 17;
			this->label8->Text = L"SP";
			// 
			// label9
			// 
			this->label9->AutoSize = true;
			this->label9->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->label9->Location = System::Drawing::Point(86, 35);
			this->label9->Name = L"label9";
			this->label9->Size = System::Drawing::Size(22, 13);
			this->label9->TabIndex = 18;
			this->label9->Text = L"AR";
			// 
			// label10
			// 
			this->label10->AutoSize = true;
			this->label10->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->label10->Location = System::Drawing::Point(81, 97);
			this->label10->Name = L"label10";
			this->label10->Size = System::Drawing::Size(28, 13);
			this->label10->TabIndex = 19;
			this->label10->Text = L"LCD";
			// 
			// m_memoryViewTextBox
			// 
			this->m_memoryViewTextBox->Anchor = static_cast<System::Windows::Forms::AnchorStyles>(((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->m_memoryViewTextBox->BackColor = System::Drawing::SystemColors::Window;
			this->m_memoryViewTextBox->Font = (gcnew System::Drawing::Font(L"Courier New", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->m_memoryViewTextBox->Location = System::Drawing::Point(421, 60);
			this->m_memoryViewTextBox->Multiline = true;
			this->m_memoryViewTextBox->Name = L"m_memoryViewTextBox";
			this->m_memoryViewTextBox->ReadOnly = true;
			this->m_memoryViewTextBox->ScrollBars = System::Windows::Forms::ScrollBars::Vertical;
			this->m_memoryViewTextBox->Size = System::Drawing::Size(582, 148);
			this->m_memoryViewTextBox->TabIndex = 20;
			this->m_memoryViewTextBox->Text = L"AAAAAA AB CD EF GH IJ KL MN OP AB CD EF GH IJ KL MN OP";
			this->m_memoryViewTextBox->WordWrap = false;
			// 
			// label11
			// 
			this->label11->AutoSize = true;
			this->label11->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->label11->Location = System::Drawing::Point(421, 37);
			this->label11->Name = L"label11";
			this->label11->Size = System::Drawing::Size(70, 13);
			this->label11->TabIndex = 21;
			this->label11->Text = L"Memory View";
			// 
			// m_cRadioButton
			// 
			this->m_cRadioButton->AutoCheck = false;
			this->m_cRadioButton->AutoSize = true;
			this->m_cRadioButton->Location = System::Drawing::Point(348, 9);
			this->m_cRadioButton->Name = L"m_cRadioButton";
			this->m_cRadioButton->Size = System::Drawing::Size(32, 17);
			this->m_cRadioButton->TabIndex = 22;
			this->m_cRadioButton->TabStop = true;
			this->m_cRadioButton->Text = L"C";
			this->m_cRadioButton->UseVisualStyleBackColor = true;
			// 
			// m_nRadioButton
			// 
			this->m_nRadioButton->AutoCheck = false;
			this->m_nRadioButton->AutoSize = true;
			this->m_nRadioButton->Location = System::Drawing::Point(348, 32);
			this->m_nRadioButton->Name = L"m_nRadioButton";
			this->m_nRadioButton->Size = System::Drawing::Size(33, 17);
			this->m_nRadioButton->TabIndex = 23;
			this->m_nRadioButton->TabStop = true;
			this->m_nRadioButton->Text = L"N";
			this->m_nRadioButton->UseVisualStyleBackColor = true;
			// 
			// m_zRadioButton
			// 
			this->m_zRadioButton->AutoCheck = false;
			this->m_zRadioButton->AutoSize = true;
			this->m_zRadioButton->Location = System::Drawing::Point(348, 54);
			this->m_zRadioButton->Name = L"m_zRadioButton";
			this->m_zRadioButton->Size = System::Drawing::Size(32, 17);
			this->m_zRadioButton->TabIndex = 24;
			this->m_zRadioButton->TabStop = true;
			this->m_zRadioButton->Text = L"Z";
			this->m_zRadioButton->UseVisualStyleBackColor = true;
			// 
			// m_vRadioButton
			// 
			this->m_vRadioButton->AutoCheck = false;
			this->m_vRadioButton->AutoSize = true;
			this->m_vRadioButton->Location = System::Drawing::Point(348, 77);
			this->m_vRadioButton->Name = L"m_vRadioButton";
			this->m_vRadioButton->Size = System::Drawing::Size(32, 17);
			this->m_vRadioButton->TabIndex = 25;
			this->m_vRadioButton->TabStop = true;
			this->m_vRadioButton->Text = L"V";
			this->m_vRadioButton->UseVisualStyleBackColor = true;
			// 
			// m_aRadioButton
			// 
			this->m_aRadioButton->AutoCheck = false;
			this->m_aRadioButton->AutoSize = true;
			this->m_aRadioButton->Location = System::Drawing::Point(348, 100);
			this->m_aRadioButton->Name = L"m_aRadioButton";
			this->m_aRadioButton->Size = System::Drawing::Size(32, 17);
			this->m_aRadioButton->TabIndex = 26;
			this->m_aRadioButton->TabStop = true;
			this->m_aRadioButton->Text = L"A";
			this->m_aRadioButton->UseVisualStyleBackColor = true;
			// 
			// m_ieRadioButton
			// 
			this->m_ieRadioButton->AutoCheck = false;
			this->m_ieRadioButton->AutoSize = true;
			this->m_ieRadioButton->Location = System::Drawing::Point(348, 123);
			this->m_ieRadioButton->Name = L"m_ieRadioButton";
			this->m_ieRadioButton->Size = System::Drawing::Size(35, 17);
			this->m_ieRadioButton->TabIndex = 27;
			this->m_ieRadioButton->TabStop = true;
			this->m_ieRadioButton->Text = L"IE";
			this->m_ieRadioButton->UseVisualStyleBackColor = true;
			// 
			// m_memoryAddressTextBox
			// 
			this->m_memoryAddressTextBox->Font = (gcnew System::Drawing::Font(L"Courier New", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->m_memoryAddressTextBox->Location = System::Drawing::Point(497, 33);
			this->m_memoryAddressTextBox->MaxLength = 6;
			this->m_memoryAddressTextBox->Name = L"m_memoryAddressTextBox";
			this->m_memoryAddressTextBox->Size = System::Drawing::Size(57, 22);
			this->m_memoryAddressTextBox->TabIndex = 28;
			this->m_memoryAddressTextBox->Text = L"ADDRES";
			this->m_memoryAddressTextBox->PreviewKeyDown += gcnew System::Windows::Forms::PreviewKeyDownEventHandler(this, &MainForm::m_memoryAddressTextBox_PreviewKeyDown);
			this->m_memoryAddressTextBox->Validated += gcnew System::EventHandler(this, &MainForm::m_memoryAddressTextBox_Validated);
			this->m_memoryAddressTextBox->KeyDown += gcnew System::Windows::Forms::KeyEventHandler(this, &MainForm::m_memoryAddressTextBox_KeyDown);
			this->m_memoryAddressTextBox->Validating += gcnew System::ComponentModel::CancelEventHandler(this, &MainForm::m_memoryAddressTextBox_Validating);
			// 
			// m_continueButtton
			// 
			this->m_continueButtton->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Left));
			this->m_continueButtton->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"m_continueButtton.Image")));
			this->m_continueButtton->Location = System::Drawing::Point(12, 804);
			this->m_continueButtton->Name = L"m_continueButtton";
			this->m_continueButtton->Size = System::Drawing::Size(32, 23);
			this->m_continueButtton->TabIndex = 32;
			this->m_continueButtton->UseVisualStyleBackColor = true;
			this->m_continueButtton->Click += gcnew System::EventHandler(this, &MainForm::m_continueButtton_Click);
			// 
			// m_pauseButton
			// 
			this->m_pauseButton->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Left));
			this->m_pauseButton->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"m_pauseButton.Image")));
			this->m_pauseButton->Location = System::Drawing::Point(62, 804);
			this->m_pauseButton->Name = L"m_pauseButton";
			this->m_pauseButton->Size = System::Drawing::Size(32, 23);
			this->m_pauseButton->TabIndex = 33;
			this->m_pauseButton->UseVisualStyleBackColor = true;
			this->m_pauseButton->Click += gcnew System::EventHandler(this, &MainForm::m_pauseButton_Click);
			// 
			// m_resetButton
			// 
			this->m_resetButton->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Left));
			this->m_resetButton->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"m_resetButton.Image")));
			this->m_resetButton->Location = System::Drawing::Point(312, 804);
			this->m_resetButton->Name = L"m_resetButton";
			this->m_resetButton->Size = System::Drawing::Size(32, 23);
			this->m_resetButton->TabIndex = 34;
			this->m_resetButton->UseVisualStyleBackColor = true;
			this->m_resetButton->Click += gcnew System::EventHandler(this, &MainForm::m_resetButton_Click);
			// 
			// label12
			// 
			this->label12->AutoSize = true;
			this->label12->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->label12->Location = System::Drawing::Point(232, 9);
			this->label12->Name = L"label12";
			this->label12->Size = System::Drawing::Size(21, 13);
			this->label12->TabIndex = 36;
			this->label12->Text = L"Op";
			// 
			// m_stepButton
			// 
			this->m_stepButton->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Left));
			this->m_stepButton->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"m_stepButton.Image")));
			this->m_stepButton->Location = System::Drawing::Point(162, 804);
			this->m_stepButton->Name = L"m_stepButton";
			this->m_stepButton->Size = System::Drawing::Size(32, 23);
			this->m_stepButton->TabIndex = 37;
			this->m_stepButton->UseVisualStyleBackColor = true;
			this->m_stepButton->Click += gcnew System::EventHandler(this, &MainForm::m_stepButton_Click);
			// 
			// m_microStepButton
			// 
			this->m_microStepButton->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Left));
			this->m_microStepButton->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"m_microStepButton.Image")));
			this->m_microStepButton->Location = System::Drawing::Point(112, 804);
			this->m_microStepButton->Name = L"m_microStepButton";
			this->m_microStepButton->Size = System::Drawing::Size(32, 23);
			this->m_microStepButton->TabIndex = 38;
			this->m_microStepButton->UseVisualStyleBackColor = true;
			this->m_microStepButton->Click += gcnew System::EventHandler(this, &MainForm::m_microStepButton_Click);
			// 
			// label13
			// 
			this->label13->AutoSize = true;
			this->label13->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->label13->Location = System::Drawing::Point(216, 62);
			this->label13->Name = L"label13";
			this->label13->Size = System::Drawing::Size(37, 13);
			this->label13->TabIndex = 40;
			this->label13->Text = L"Phase";
			// 
			// m_phaseLabel
			// 
			this->m_phaseLabel->AutoSize = true;
			this->m_phaseLabel->BackColor = System::Drawing::SystemColors::Window;
			this->m_phaseLabel->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->m_phaseLabel->Font = (gcnew System::Drawing::Font(L"Courier New", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->m_phaseLabel->Location = System::Drawing::Point(259, 61);
			this->m_phaseLabel->Name = L"m_phaseLabel";
			this->m_phaseLabel->Size = System::Drawing::Size(26, 18);
			this->m_phaseLabel->TabIndex = 39;
			this->m_phaseLabel->Text = L"AB";
			// 
			// panel1
			// 
			this->panel1->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->panel1->Controls->Add(this->m_opLabel);
			this->panel1->Controls->Add(this->m_irqRadioButton);
			this->panel1->Controls->Add(this->label13);
			this->panel1->Controls->Add(this->m_ieRadioButton);
			this->panel1->Controls->Add(this->m_phaseLabel);
			this->panel1->Controls->Add(this->m_lcdTextBox);
			this->panel1->Controls->Add(this->m_aRadioButton);
			this->panel1->Controls->Add(this->label12);
			this->panel1->Controls->Add(this->label10);
			this->panel1->Controls->Add(this->m_vRadioButton);
			this->panel1->Controls->Add(this->m_aLabel);
			this->panel1->Controls->Add(this->label9);
			this->panel1->Controls->Add(this->m_zRadioButton);
			this->panel1->Controls->Add(this->label8);
			this->panel1->Controls->Add(this->m_xLabel);
			this->panel1->Controls->Add(this->label7);
			this->panel1->Controls->Add(this->m_nRadioButton);
			this->panel1->Controls->Add(this->m_spLabel);
			this->panel1->Controls->Add(this->m_cRadioButton);
			this->panel1->Controls->Add(this->m_arLabel);
			this->panel1->Controls->Add(this->m_pcLabel);
			this->panel1->Controls->Add(this->m_yLabel);
			this->panel1->Controls->Add(this->m_tLabel);
			this->panel1->Controls->Add(this->label1);
			this->panel1->Controls->Add(this->label2);
			this->panel1->Controls->Add(this->label3);
			this->panel1->Controls->Add(this->label4);
			this->panel1->Controls->Add(this->label6);
			this->panel1->Controls->Add(this->m_opcodeLabel);
			this->panel1->Location = System::Drawing::Point(12, 37);
			this->panel1->Name = L"panel1";
			this->panel1->Size = System::Drawing::Size(403, 171);
			this->panel1->TabIndex = 41;
			// 
			// m_opLabel
			// 
			this->m_opLabel->AutoSize = true;
			this->m_opLabel->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->m_opLabel->Location = System::Drawing::Point(259, 9);
			this->m_opLabel->Name = L"m_opLabel";
			this->m_opLabel->Size = System::Drawing::Size(33, 13);
			this->m_opLabel->TabIndex = 42;
			this->m_opLabel->Text = L"NOP";
			// 
			// m_irqRadioButton
			// 
			this->m_irqRadioButton->AutoCheck = false;
			this->m_irqRadioButton->AutoSize = true;
			this->m_irqRadioButton->Location = System::Drawing::Point(348, 146);
			this->m_irqRadioButton->Name = L"m_irqRadioButton";
			this->m_irqRadioButton->Size = System::Drawing::Size(44, 17);
			this->m_irqRadioButton->TabIndex = 41;
			this->m_irqRadioButton->TabStop = true;
			this->m_irqRadioButton->Text = L"IRQ";
			this->m_irqRadioButton->UseVisualStyleBackColor = true;
			// 
			// m_microDisassemblyViewTitle
			// 
			this->m_microDisassemblyViewTitle->AutoSize = true;
			this->m_microDisassemblyViewTitle->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, 
				System::Drawing::GraphicsUnit::Point, static_cast<System::Byte>(0)));
			this->m_microDisassemblyViewTitle->Location = System::Drawing::Point(9, 212);
			this->m_microDisassemblyViewTitle->Name = L"m_microDisassemblyViewTitle";
			this->m_microDisassemblyViewTitle->Size = System::Drawing::Size(120, 13);
			this->m_microDisassemblyViewTitle->TabIndex = 43;
			this->m_microDisassemblyViewTitle->Text = L"Micro-Disassembly View";
			// 
			// label14
			// 
			this->label14->AutoSize = true;
			this->label14->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->label14->Location = System::Drawing::Point(489, 344);
			this->label14->Name = L"label14";
			this->label14->Size = System::Drawing::Size(67, 13);
			this->label14->TabIndex = 45;
			this->label14->Text = L"Source View";
			// 
			// m_sourceListView
			// 
			this->m_sourceListView->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->m_sourceListView->AutoArrange = false;
			this->m_sourceListView->Columns->AddRange(gcnew cli::array< System::Windows::Forms::ColumnHeader^  >(1) {this->columnHeader1});
			this->m_sourceListView->Font = (gcnew System::Drawing::Font(L"Courier New", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->m_sourceListView->HeaderStyle = System::Windows::Forms::ColumnHeaderStyle::None;
			this->m_sourceListView->LabelWrap = false;
			this->m_sourceListView->Location = System::Drawing::Point(491, 360);
			this->m_sourceListView->MultiSelect = false;
			this->m_sourceListView->Name = L"m_sourceListView";
			this->m_sourceListView->ShowGroups = false;
			this->m_sourceListView->Size = System::Drawing::Size(512, 431);
			this->m_sourceListView->SmallImageList = this->m_debuggerImageList;
			this->m_sourceListView->TabIndex = 46;
			this->m_sourceListView->UseCompatibleStateImageBehavior = false;
			this->m_sourceListView->View = System::Windows::Forms::View::Details;
			this->m_sourceListView->MouseClick += gcnew System::Windows::Forms::MouseEventHandler(this, &MainForm::m_sourceListView_MouseClick);
			this->m_sourceListView->ItemSelectionChanged += gcnew System::Windows::Forms::ListViewItemSelectionChangedEventHandler(this, &MainForm::m_sourceListView_ItemSelectionChanged);
			// 
			// columnHeader1
			// 
			this->columnHeader1->Width = 582;
			// 
			// m_debuggerImageList
			// 
			this->m_debuggerImageList->ImageStream = (cli::safe_cast<System::Windows::Forms::ImageListStreamer^  >(resources->GetObject(L"m_debuggerImageList.ImageStream")));
			this->m_debuggerImageList->TransparentColor = System::Drawing::Color::Transparent;
			this->m_debuggerImageList->Images->SetKeyName(0, L"arrow");
			this->m_debuggerImageList->Images->SetKeyName(1, L"breakpoint");
			this->m_debuggerImageList->Images->SetKeyName(2, L"breakpoint with arrow");
			this->m_debuggerImageList->Images->SetKeyName(3, L"stackframe");
			this->m_debuggerImageList->Images->SetKeyName(4, L"breakpoint with stackframe");
			// 
			// m_microSourceListView
			// 
			this->m_microSourceListView->AutoArrange = false;
			this->m_microSourceListView->Columns->AddRange(gcnew cli::array< System::Windows::Forms::ColumnHeader^  >(1) {this->columnHeader2});
			this->m_microSourceListView->Font = (gcnew System::Drawing::Font(L"Courier New", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->m_microSourceListView->HeaderStyle = System::Windows::Forms::ColumnHeaderStyle::None;
			this->m_microSourceListView->LabelWrap = false;
			this->m_microSourceListView->Location = System::Drawing::Point(9, 228);
			this->m_microSourceListView->Margin = System::Windows::Forms::Padding(0);
			this->m_microSourceListView->MultiSelect = false;
			this->m_microSourceListView->Name = L"m_microSourceListView";
			this->m_microSourceListView->ShowGroups = false;
			this->m_microSourceListView->Size = System::Drawing::Size(476, 106);
			this->m_microSourceListView->SmallImageList = this->m_debuggerImageList;
			this->m_microSourceListView->TabIndex = 47;
			this->m_microSourceListView->UseCompatibleStateImageBehavior = false;
			this->m_microSourceListView->View = System::Windows::Forms::View::Details;
			this->m_microSourceListView->MouseClick += gcnew System::Windows::Forms::MouseEventHandler(this, &MainForm::m_microSourceListView_MouseClick);
			this->m_microSourceListView->SizeChanged += gcnew System::EventHandler(this, &MainForm::m_microSourceListView_SizeChanged);
			this->m_microSourceListView->ItemSelectionChanged += gcnew System::Windows::Forms::ListViewItemSelectionChangedEventHandler(this, &MainForm::m_microSourceListView_ItemSelectionChanged);
			// 
			// columnHeader2
			// 
			this->columnHeader2->Width = 399;
			// 
			// m_clearBreakpointsButton
			// 
			this->m_clearBreakpointsButton->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Right));
			this->m_clearBreakpointsButton->Location = System::Drawing::Point(877, 799);
			this->m_clearBreakpointsButton->Name = L"m_clearBreakpointsButton";
			this->m_clearBreakpointsButton->Size = System::Drawing::Size(127, 23);
			this->m_clearBreakpointsButton->TabIndex = 48;
			this->m_clearBreakpointsButton->Text = L"Delete All Breakpoints";
			this->m_clearBreakpointsButton->UseVisualStyleBackColor = true;
			this->m_clearBreakpointsButton->Click += gcnew System::EventHandler(this, &MainForm::m_clearBreakpointsButton_Click);
			// 
			// menuStrip1
			// 
			this->menuStrip1->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(1) {this->fileToolStripMenuItem});
			this->menuStrip1->Location = System::Drawing::Point(0, 0);
			this->menuStrip1->Name = L"menuStrip1";
			this->menuStrip1->Size = System::Drawing::Size(1016, 24);
			this->menuStrip1->TabIndex = 49;
			this->menuStrip1->Text = L"menuStrip1";
			// 
			// fileToolStripMenuItem
			// 
			this->fileToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(8) {this->openProgramROMToolStripMenuItem, 
				this->toolStripMenuItem2, this->toolStripMenuItem3, this->toolStripMenuItem4, this->toolStripMenuItem5, this->toolStripMenuItem6, 
				this->toolStripMenuItem1, this->exitToolStripMenuItem});
			this->fileToolStripMenuItem->Name = L"fileToolStripMenuItem";
			this->fileToolStripMenuItem->Size = System::Drawing::Size(35, 20);
			this->fileToolStripMenuItem->Text = L"File";
			// 
			// openProgramROMToolStripMenuItem
			// 
			this->openProgramROMToolStripMenuItem->Name = L"openProgramROMToolStripMenuItem";
			this->openProgramROMToolStripMenuItem->Size = System::Drawing::Size(214, 22);
			this->openProgramROMToolStripMenuItem->Text = L"Open Program File...";
			this->openProgramROMToolStripMenuItem->Click += gcnew System::EventHandler(this, &MainForm::openProgramROMToolStripMenuItem_Click);
			// 
			// toolStripMenuItem2
			// 
			this->toolStripMenuItem2->Name = L"toolStripMenuItem2";
			this->toolStripMenuItem2->Size = System::Drawing::Size(214, 22);
			this->toolStripMenuItem2->Text = L"Open Symbol File...";
			this->toolStripMenuItem2->Click += gcnew System::EventHandler(this, &MainForm::toolStripMenuItem2_Click);
			// 
			// toolStripMenuItem3
			// 
			this->toolStripMenuItem3->Name = L"toolStripMenuItem3";
			this->toolStripMenuItem3->Size = System::Drawing::Size(214, 22);
			this->toolStripMenuItem3->Text = L"Set Program Load Address...";
			this->toolStripMenuItem3->Click += gcnew System::EventHandler(this, &MainForm::toolStripMenuItem3_Click);
			// 
			// toolStripMenuItem4
			// 
			this->toolStripMenuItem4->Name = L"toolStripMenuItem4";
			this->toolStripMenuItem4->Size = System::Drawing::Size(214, 22);
			this->toolStripMenuItem4->Text = L"Set Program Start Address...";
			this->toolStripMenuItem4->Click += gcnew System::EventHandler(this, &MainForm::toolStripMenuItem4_Click);
			// 
			// toolStripMenuItem5
			// 
			this->toolStripMenuItem5->Name = L"toolStripMenuItem5";
			this->toolStripMenuItem5->Size = System::Drawing::Size(214, 22);
			this->toolStripMenuItem5->Text = L"Set Memory Breakpoint...";
			this->toolStripMenuItem5->Click += gcnew System::EventHandler(this, &MainForm::toolStripMenuItem5_Click);
			// 
			// toolStripMenuItem6
			// 
			this->toolStripMenuItem6->Name = L"toolStripMenuItem6";
			this->toolStripMenuItem6->Size = System::Drawing::Size(214, 22);
			this->toolStripMenuItem6->Text = L"Clear Memory Breakpoint";
			this->toolStripMenuItem6->Click += gcnew System::EventHandler(this, &MainForm::toolStripMenuItem6_Click);
			// 
			// toolStripMenuItem1
			// 
			this->toolStripMenuItem1->Name = L"toolStripMenuItem1";
			this->toolStripMenuItem1->Size = System::Drawing::Size(211, 6);
			// 
			// exitToolStripMenuItem
			// 
			this->exitToolStripMenuItem->Name = L"exitToolStripMenuItem";
			this->exitToolStripMenuItem->Size = System::Drawing::Size(214, 22);
			this->exitToolStripMenuItem->Text = L"Exit";
			this->exitToolStripMenuItem->Click += gcnew System::EventHandler(this, &MainForm::exitToolStripMenuItem_Click);
			// 
			// m_ShowDisassemblyCheckbox
			// 
			this->m_ShowDisassemblyCheckbox->AutoSize = true;
			this->m_ShowDisassemblyCheckbox->Location = System::Drawing::Point(593, 343);
			this->m_ShowDisassemblyCheckbox->Name = L"m_ShowDisassemblyCheckbox";
			this->m_ShowDisassemblyCheckbox->Size = System::Drawing::Size(114, 17);
			this->m_ShowDisassemblyCheckbox->TabIndex = 50;
			this->m_ShowDisassemblyCheckbox->Text = L"Show Disassembly";
			this->m_ShowDisassemblyCheckbox->UseVisualStyleBackColor = true;
			this->m_ShowDisassemblyCheckbox->CheckedChanged += gcnew System::EventHandler(this, &MainForm::m_ShowDisassemblyCheckbox_CheckedChanged);
			// 
			// m_stepInButton
			// 
			this->m_stepInButton->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Left));
			this->m_stepInButton->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"m_stepInButton.Image")));
			this->m_stepInButton->Location = System::Drawing::Point(212, 804);
			this->m_stepInButton->Name = L"m_stepInButton";
			this->m_stepInButton->Size = System::Drawing::Size(32, 23);
			this->m_stepInButton->TabIndex = 51;
			this->m_stepInButton->UseVisualStyleBackColor = true;
			this->m_stepInButton->Click += gcnew System::EventHandler(this, &MainForm::m_stepInButton_Click);
			// 
			// m_stepOutButton
			// 
			this->m_stepOutButton->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Left));
			this->m_stepOutButton->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"m_stepOutButton.Image")));
			this->m_stepOutButton->Location = System::Drawing::Point(262, 804);
			this->m_stepOutButton->Name = L"m_stepOutButton";
			this->m_stepOutButton->Size = System::Drawing::Size(32, 23);
			this->m_stepOutButton->TabIndex = 52;
			this->m_stepOutButton->UseVisualStyleBackColor = true;
			this->m_stepOutButton->Click += gcnew System::EventHandler(this, &MainForm::m_stepOutButton_Click);
			// 
			// m_callStackListView
			// 
			this->m_callStackListView->Anchor = static_cast<System::Windows::Forms::AnchorStyles>(((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->m_callStackListView->AutoArrange = false;
			this->m_callStackListView->Columns->AddRange(gcnew cli::array< System::Windows::Forms::ColumnHeader^  >(1) {this->columnHeader3});
			this->m_callStackListView->Font = (gcnew System::Drawing::Font(L"Courier New", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->m_callStackListView->HeaderStyle = System::Windows::Forms::ColumnHeaderStyle::None;
			this->m_callStackListView->LabelWrap = false;
			this->m_callStackListView->Location = System::Drawing::Point(491, 228);
			this->m_callStackListView->Margin = System::Windows::Forms::Padding(0);
			this->m_callStackListView->MultiSelect = false;
			this->m_callStackListView->Name = L"m_callStackListView";
			this->m_callStackListView->ShowGroups = false;
			this->m_callStackListView->Size = System::Drawing::Size(512, 106);
			this->m_callStackListView->SmallImageList = this->m_debuggerImageList;
			this->m_callStackListView->TabIndex = 53;
			this->m_callStackListView->UseCompatibleStateImageBehavior = false;
			this->m_callStackListView->View = System::Windows::Forms::View::Details;
			this->m_callStackListView->MouseDoubleClick += gcnew System::Windows::Forms::MouseEventHandler(this, &MainForm::m_callStackListView_MouseDoubleClick);
			// 
			// columnHeader3
			// 
			this->columnHeader3->Width = 399;
			// 
			// m_callStackTitle
			// 
			this->m_callStackTitle->AutoSize = true;
			this->m_callStackTitle->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, 
				System::Drawing::GraphicsUnit::Point, static_cast<System::Byte>(0)));
			this->m_callStackTitle->Location = System::Drawing::Point(489, 212);
			this->m_callStackTitle->Name = L"m_callStackTitle";
			this->m_callStackTitle->Size = System::Drawing::Size(55, 13);
			this->m_callStackTitle->TabIndex = 54;
			this->m_callStackTitle->Text = L"Call Stack";
			// 
			// MainForm
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(1016, 846);
			this->Controls->Add(this->m_callStackTitle);
			this->Controls->Add(this->m_callStackListView);
			this->Controls->Add(this->m_stepOutButton);
			this->Controls->Add(this->m_stepInButton);
			this->Controls->Add(this->m_ShowDisassemblyCheckbox);
			this->Controls->Add(this->m_clearBreakpointsButton);
			this->Controls->Add(this->m_microSourceListView);
			this->Controls->Add(this->m_sourceListView);
			this->Controls->Add(this->label14);
			this->Controls->Add(this->m_microDisassemblyViewTitle);
			this->Controls->Add(this->m_microStepButton);
			this->Controls->Add(this->m_stepButton);
			this->Controls->Add(this->m_resetButton);
			this->Controls->Add(this->m_pauseButton);
			this->Controls->Add(this->m_continueButtton);
			this->Controls->Add(this->m_memoryAddressTextBox);
			this->Controls->Add(this->label11);
			this->Controls->Add(this->m_memoryViewTextBox);
			this->Controls->Add(this->m_consoleTextBoxLabel);
			this->Controls->Add(this->m_consoleTextBox);
			this->Controls->Add(this->panel1);
			this->Controls->Add(this->menuStrip1);
			this->Icon = (cli::safe_cast<System::Drawing::Icon^  >(resources->GetObject(L"$this.Icon")));
			this->MainMenuStrip = this->menuStrip1;
			this->Name = L"MainForm";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = L"BMOW";
			this->Load += gcnew System::EventHandler(this, &MainForm::MainForm_Load);
			this->panel1->ResumeLayout(false);
			this->panel1->PerformLayout();
			this->menuStrip1->ResumeLayout(false);
			this->menuStrip1->PerformLayout();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion
public:
	unsigned long m_memoryBreakpointAddress;
private: 
	MachineState^ m_machineState;
	Disassembly^ m_disassembler;
	MicroDisassembly^ m_microDisassembler;
	unsigned char m_executingOpcode;
	unsigned long m_executingPC;
	unsigned long m_memoryViewAddress;
	unsigned long m_currentInstructionAddress;
	unsigned long m_sourceDisassemblyStartAddress;
	unsigned long m_stepOverDestinationAddress;
	unsigned long m_loadAddress;
	unsigned long m_bootAddress;
	unsigned long m_keyboardAdrKeyBuffer;
	unsigned long m_keyboardAdrModifierBuffer;
	unsigned long m_keyboardAdrKeyReady;
	unsigned long m_currentStackFrameAddress;
	String^ m_bootImage;
	bool m_ignoreSource;
	bool m_running;
	bool m_steppingOut;
	int m_stepOutCount;
	int m_stepsSinceLastInterrupt;
	int m_refreshCycles;
	DateTime m_lastUpdateTime;
	Dictionary<unsigned long, bool> m_sourceBreakpoints;
	Dictionary<unsigned long, List<unsigned long>^> m_microSourceBreakpoints;
	Dictionary<unsigned long, FileAndLine> m_addressToSource;
	Dictionary<String^, unsigned long> m_sourceStartAddress;
	List<unsigned long> m_stackFrames;

	void MainForm_Load(System::Object^  sender, System::EventArgs^  e) 
	{
		Application::Idle += gcnew System::EventHandler(this, &MainForm::OnIdle);
		InitializeSimulation();
	}

	void OnIdle(System::Object^  sender, System::EventArgs^  e);

	void m_memoryAddressTextBox_Validating(System::Object^  sender, System::ComponentModel::CancelEventArgs^  e) 
	{
		UInt32 value;
		if (UInt32::TryParse(m_memoryAddressTextBox->Text, NumberStyles::HexNumber, NumberFormatInfo::InvariantInfo, value))
		{
			// make sure it's a 24-bit address
			if ((value & 0xFF000000) == 0)
			{
				m_memoryViewAddress = value;
				return;
			}
		}

		m_memoryAddressTextBox->Text = String::Format("{0:X6}", m_memoryViewAddress);
		e->Cancel = true;
	}

	void m_memoryAddressTextBox_Validated(System::Object^  sender, System::EventArgs^  e) 
	{
		FillMemoryTextBox(m_memoryViewTextBox, m_memoryViewAddress, 0, false);
	}

	void m_memoryAddressTextBox_PreviewKeyDown(System::Object^  sender, System::Windows::Forms::PreviewKeyDownEventArgs^  e) 
	{
		switch (e->KeyCode)
		{
		case Keys::Return:
			e->IsInputKey = true;
			break;
		}
	}

	void m_memoryAddressTextBox_KeyDown(System::Object^  sender, System::Windows::Forms::KeyEventArgs^  e) 
	{
		switch (e->KeyCode)
		{
		case Keys::Return:
			UInt32 value;
			if (UInt32::TryParse(m_memoryAddressTextBox->Text, NumberStyles::HexNumber, NumberFormatInfo::InvariantInfo, value))
			{
				// make sure it's a 24-bit address
				if ((value & 0xFF000000) == 0)
				{
					m_memoryViewAddress = value;
					FillMemoryTextBox(m_memoryViewTextBox, m_memoryViewAddress, 0, false);
					e->Handled = true;
					e->SuppressKeyPress = true;
					return;
				}
			}
			
			break;
		}
	}

	void m_sourceListView_MouseClick(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) 
	{
		if (!m_running)
		{
			ListView^ sourceListView = safe_cast<ListView^>(sender);
			ListViewItem^ clickedItem = sourceListView->GetItemAt(e->X, e->Y);
			if (clickedItem)
			{
				unsigned long breakpointAddress = safe_cast<unsigned long>(clickedItem->Tag);

				if (m_sourceBreakpoints.ContainsKey(breakpointAddress))
				{
					m_sourceBreakpoints.Remove(breakpointAddress);
				}
				else
				{
					m_sourceBreakpoints[breakpointAddress] = true;
				}
			}

			RefreshDisassemblyView(false);
		}
	}

	void m_microSourceListView_MouseClick(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) 
	{
		if (!m_running)
		{
			ListView^ microSourceListView = safe_cast<ListView^>(sender);
			ListViewItem^ clickedItem = microSourceListView->GetItemAt(e->X, e->Y);
			if (clickedItem)
			{
				KeyValuePair<unsigned long, unsigned long>^ breakpointData = safe_cast<KeyValuePair<unsigned long, unsigned long>^>(clickedItem->Tag);

				if (m_microSourceBreakpoints.ContainsKey(breakpointData->Key))
				{
					bool breakpointFound = false;
					
					List<unsigned long>^ conditionCodes = m_microSourceBreakpoints[breakpointData->Key];
					for each (unsigned long conditionCode in conditionCodes)
					{
						if (conditionCode == breakpointData->Value)
						{
							conditionCodes->Remove(conditionCode);
							if (conditionCodes->Count == 0)
							{
								m_microSourceBreakpoints.Remove(breakpointData->Key);
							}
							breakpointFound = true;
							break;
						}
					}

					if (!breakpointFound)
					{
						conditionCodes->Add(breakpointData->Value);
					}
				}
				else
				{
					List<unsigned long>^ conditionCodes = gcnew List<unsigned long>();
					conditionCodes->Add(breakpointData->Value);
					m_microSourceBreakpoints[breakpointData->Key] = conditionCodes;
				}
			}

			RefreshMicroDisassemblyView();
		}
	}

	void m_callStackListView_MouseDoubleClick(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) 
	{
		ListView^ listView = safe_cast<ListView^>(sender);
		ListViewItem^ clickedItem = listView->GetItemAt(e->X, e->Y);
		unsigned int newStackFrameAddress = safe_cast<unsigned int>(clickedItem->Tag);

		m_currentStackFrameAddress = newStackFrameAddress;
		
		// update icons
		for each (ListViewItem^ listItem in m_callStackListView->Items)
		{
			if (listItem->Index != 0)
			{
				listItem->ImageKey = nullptr;
			}	
		}

		if (clickedItem->Index != 0)
		{
			clickedItem->ImageKey = "stackframe";
		}
		else
		{
			// fix for refresh glitch?
			clickedItem->ImageKey = nullptr;
			clickedItem->ImageKey = "arrow";
		}

		RefreshDisassemblyView(true);
	}

	void m_clearBreakpointsButton_Click(System::Object^  sender, System::EventArgs^  e) 
	{
		m_sourceBreakpoints.Clear();
		m_microSourceBreakpoints.Clear();

		RefreshDisassemblyView(false);
		RefreshMicroDisassemblyView();
	}
	
	void m_sourceListView_ItemSelectionChanged(System::Object^  sender, System::Windows::Forms::ListViewItemSelectionChangedEventArgs^  e) 
	{
		e->Item->Selected = false;
	}

	void m_microSourceListView_ItemSelectionChanged(System::Object^  sender, System::Windows::Forms::ListViewItemSelectionChangedEventArgs^  e) 
	{
		e->Item->Selected = false;	
	}

	void m_microSourceListView_SizeChanged(System::Object^  sender, System::EventArgs^  e) 
	{
	//	ListView^ listView = safe_cast<ListView^>(sender);
	//	listView->Columns[0]->Width = listView->Width - 4;
	}

	void m_microStepButton_Click(System::Object^  sender, System::EventArgs^  e);

	void m_stepButton_Click(System::Object^  sender, System::EventArgs^  e);
	
	void m_stepInButton_Click(System::Object^  sender, System::EventArgs^  e);

	void m_stepOutButton_Click(System::Object^  sender, System::EventArgs^  e);

	void m_resetButton_Click(System::Object^  sender, System::EventArgs^  e);

	void m_continueButtton_Click(System::Object^  sender, System::EventArgs^  e);

	void m_pauseButton_Click(System::Object^  sender, System::EventArgs^  e);

	void m_lcdTextBox_KeyPress(System::Object^  sender, System::Windows::Forms::KeyPressEventArgs^  e); 

	void toolStripMenuItem2_Click(System::Object^  sender, System::EventArgs^  e);

	void openProgramROMToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e);

	void InitializeSimulation();
	bool CurrentMicroaddressIsAtBreakpoint();
	void RefreshData();
	void RefreshDisassemblyView(bool scrollToCurrentInstruction);
	void RefreshMicroDisassemblyView();
	void RefreshCallStack();
	String^ GetNameForStackFrame(unsigned long addr);
	void FillMemoryTextBox(TextBox^ textBox, unsigned long startAddress, unsigned long highlightAddress, bool highlight);
	void FillConsoleTextBox(TextBox^ textBox);
	void LoadSourceLabels(String^ filename);
	bool RetireInstruction();
	void m_ShowDisassemblyCheckbox_CheckedChanged(System::Object^  sender, System::EventArgs^  e);
	void exitToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			 Application::Exit();
		 }


	void toolStripMenuItem3_Click(System::Object^  sender, System::EventArgs^  e);
	void toolStripMenuItem4_Click(System::Object^  sender, System::EventArgs^  e);
	void toolStripMenuItem5_Click(System::Object^  sender, System::EventArgs^  e);
	void toolStripMenuItem6_Click(System::Object^  sender, System::EventArgs^  e);
};
}

